﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Method_dekstra
{
    internal class Deikstra
    {
        int[,] Matrix;
        int start;
        int count_sum;
        int[] massive_vershin;
        bool[] Check_bool;

        public Deikstra(int[,] Matrix, int start, int count_sum)
        {
            this.Matrix = Matrix;
            this.start = start - 1;
            this.count_sum = count_sum;
            massive_vershin = new int[count_sum];
            Check_bool = new bool[count_sum];
            for (int i = 0; i < count_sum; i++)
            {
                massive_vershin[i] = int.MaxValue;
                Check_bool[i] = false;
            }
        }

        public void Deikstra_min()
        {
            massive_vershin[start] = 0;
            for (int i = 0; i < count_sum - 1; i++) //Цикл для проверки на посещенность вершины, если она не посещена, то выстраивается маршрут до нее
            {
                int minValue = int.MaxValue;
                int id_matrix = -1;
                for (int j = 0; j < count_sum; j++)
                {
                    if (Check_bool[j] is false & massive_vershin[j] < minValue)
                    {
                        minValue = massive_vershin[j];
                        id_matrix = j;
                    }
                }
                Check_bool[id_matrix] = true;

                //Цикл для проверки на возможность изменения значения вершины
                for (int j = 0; j < count_sum; j++)
                {
                    if (!Check_bool[j] & Matrix[id_matrix, j] != 0 & Matrix[id_matrix, j] + minValue < massive_vershin[j])
                        massive_vershin[j] = Matrix[id_matrix, j] + minValue;
                }
            }
            
        }
        public string Exemple()
        {
            Console.WriteLine("Вывод решения: ");
            string massive_vershin_ex = string.Empty;
            for (int i = 1; i < count_sum; i++)
                massive_vershin_ex += $"{start + 1} -> {i + 1}: {massive_vershin[i]}\n";
            return massive_vershin_ex;
        }
    }
}
